Index: .bzrignore
===================================================================
--- .bzrignore	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ .bzrignore	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -11,4 +11,8 @@
 *.aps
 *.clw
+user-guide.txt
+user-guide.html
+help.txt
 debian
+build-arch-stamp
 tags
Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ bitlbee.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -539,5 +539,5 @@
 		}
 	
-	irc_usermsg( irc, "Unknown command: %s. Please use help commands to get a list of available commands.", cmd[0] );
+	irc_usermsg( irc, "Unknown command: %s. Please use \x02help commands\x02 to get a list of available commands.", cmd[0] );
 	
 	return( 1 );
Index: bitlbee.conf
===================================================================
--- bitlbee.conf	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ bitlbee.conf	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -13,5 +13,5 @@
 ##    stable enough to serve lots of users from one process. Because of this
 ##    and other reasons, the use of daemon-mode is *STRONGLY* discouraged,
-##    don't think about reporting bugs when you use this!
+##    don't even *think* of reporting bugs when you use this.
 ##
 # RunMode = Inetd
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ bitlbee.h	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -81,5 +81,5 @@
 
 #define ROOT_NICK "root"
-#define ROOT_CHAN "#bitlbee"
+#define ROOT_CHAN "&bitlbee"
 #define ROOT_FN "User manager"
 
Index: commands.c
===================================================================
--- commands.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ commands.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -326,5 +326,5 @@
 	else
 	{
-		irc_usermsg( irc, "Unknown command: account %s. Please use help commands to get a list of available commands.", cmd[1] );
+		irc_usermsg( irc, "Unknown command: account %s. Please use \x02help commands\x02 to get a list of available commands.", cmd[1] );
 	}
 	
@@ -727,5 +727,8 @@
 	
 	for( num = 0; q; q = q->next, num ++ )
-		irc_usermsg( irc, "%d, %s", num, q->question );
+		if( q->gc ) /* Not necessary yet, but it might come later */
+			irc_usermsg( irc, "%d, %s(%s): %s", num, q->gc->prpl->name, q->gc->username, q->question );
+		else
+			irc_usermsg( irc, "%d, BitlBee: %s", num, q->question );
 	
 	return( 0 );
Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ doc/CHANGES	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -2,4 +2,10 @@
 - Removed some crashy debugging code.
 - QUIT command now works before logging in. (Mainly an RFC-compliancy fix.)
+- Hopefully slightly clearer handling of buddy add requests.
+- set buddy_sendbuffer_delay now also supports milisecond precision.
+- Renamed #bitlbee to &bitlbee to avoid confusion with the channel on OFTC.
+- Reviewed the xinetd file and installation instructions.
+- HTML stripping is configurable again.
+- Quit messages (at least on crashes) should appear again.
 
 Finished ...
Index: doc/FAQ
===================================================================
--- doc/FAQ	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ doc/FAQ	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -38,19 +38,4 @@
    artistic creativity.
 
-Q: Why is there no mailing list/CVS/<insert your favourite development tool
-   here>?
-A: Short answer: we don't need it.
-   
-   Longer answer: and we're not completely convinced of their merits.
-   
-   Long answer: we currently use some shell scripts which make sure all
-   developers' copies are in sync with Wilmer's master copy. These shell
-   scripts also produce development "releases" and packages, as well as
-   stick them on a http-server. Patches are sent to Wilmer who decides
-   whether or not a patch should be applied and if it may need some
-   additional changes. This has the consistency advantage of a one-person
-   project while having the capacity of more people available. The system
-   works and we are kind of attached to it.
-   
 Q: When is $random_feature going to be implemented?
 A: Please do consult doc/TODO (preferably in a development snapshot, which
Index: doc/README
===================================================================
--- doc/README	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ doc/README	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -9,4 +9,6 @@
 make install will move all the files to the right places.
 
+--- inetd installation
+
 After installation you have to set up inetd (you got that one running,
 right? If not, just take a look at utils/bitlbeed.c) to start BitlBee. You
@@ -18,9 +20,25 @@
 of just 'nobody') might be a good idea.
 
+*BSD/Darwin/OSX NOTE: Most *BSD inetds are more scrict than the one that
+comes with Linux systems. Possibly all non-Linux inetds are like this. They
+don't allow you to specify a port number in the inetd.conf entry, instead
+you have to put a service name there (one that is also mentioned in
+/etc/services). So if there's no line in /services for 6667/tcp (or whatever
+you choose), add it and use that name in the inetd.conf entry.
+
+-- xinetd installation
+
+Most machines use xinetd instead of inetd these days. If your machine runs
+xinetd, you can copy the bitlbee.xinetd file from the doc/ directory to your
+xinetd.d/ directory. Most likely you'll have to change a thing or two before
+it'll work.
+
+After configuring your (x)inetd, send the daemon a SIGHUP and things should
+work. If not, see your syslogs, since both daemons will complain there when
+something's wrong.
+
 Also, don't forget to create the configuration directory (/var/lib/bitlbee/
 by default) and chown it to the UID BitlBee is running as. Make sure this
 directory is read-/writable by this user only.
-
-(For xinetd users a xinetd configuration file is included: doc/bitlbee.xinetd)
 
 
@@ -48,13 +66,4 @@
 ==================
 
-FreeBSD NOTE: It looks like FreeBSD does allow port numbers instead of service
-names in inetd.conf, as long as the service for this port exists in
-/etc/services. Linux isn't this strict. If you got problems in FreeBSD, just
-add a line for your chosen port number to /etc/services.
-
-Darwin/Mac OS X is even more strict; you should add a bitlbee service to
-/etc/services and use that name in inetd.conf. Not really a problem, since
-that's the cleanest way of doing this on any operating system anyway.
-
 Cygwin NOTE: You'll need a glib installation to run BitlBee. However, Cygwin
 doesn't provide a glib package. You can download a binary tar.gz from:
@@ -66,4 +75,13 @@
 Please do report them, we might be able to fix them if they're not too
 mysterious.
+
+Also, the configure script is known to not work very well with non-Bash
+shells, so if you experience problems, make sure you use bash to run the
+script. Same for the Makefile, it only works well with GNU make. (gmake on
+most BSD systems)
+
+If someone can tell us how to write Makefiles that work with both/all
+versions of make, we'd love to hear it, but it seems this just isn't
+possible.
 
 
Index: doc/bitlbee.xinetd
===================================================================
--- doc/bitlbee.xinetd	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ doc/bitlbee.xinetd	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -2,11 +2,18 @@
 ## user, port and/or binary location might be wrong.
 
-service 6667
+## This file assumes you have ircd somewhere in your /etc/services, if things
+## don't work, check that file first.
+service ircd
 {
 	socket_type     = stream
 	protocol        = tcp
 	wait            = no
+	
+	## You most likely want to change these two
 	user            = nobody
 	server          = /usr/local/sbin/bitlbee
-	port		= 6667
+	
+	## xinetd is fucking retarded, what's the use of this port flag if
+	## it HAS to be the same as in /etc/services ?
+	# port		= 6667
 }
Index: irc.c
===================================================================
--- irc.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ irc.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -115,5 +115,5 @@
 	set_add( irc, "auto_reconnect_delay", "300", set_eval_int );
 	set_add( irc, "buddy_sendbuffer", "false", set_eval_bool );
-	set_add( irc, "buddy_sendbuffer_delay", "1", set_eval_int );
+	set_add( irc, "buddy_sendbuffer_delay", "200", set_eval_int );
 	set_add( irc, "charset", "iso8859-1", set_eval_charset );
 	set_add( irc, "debug", "false", set_eval_bool );
@@ -121,5 +121,4 @@
 	set_add( irc, "display_namechanges", "false", set_eval_bool );
 	set_add( irc, "handle_unknown", "root", NULL );
-	/* set_add( irc, "html", "nostrip", NULL ); */
 	set_add( irc, "lcnicks", "true", set_eval_bool );
 	set_add( irc, "ops", "both", set_eval_ops );
@@ -127,4 +126,5 @@
 	set_add( irc, "query_order", "lifo", NULL );
 	set_add( irc, "save_on_quit", "true", set_eval_bool );
+	set_add( irc, "strip_html", "true", NULL );
 	set_add( irc, "to_char", ": ", set_eval_to_char );
 	set_add( irc, "typing_notice", "false", set_eval_bool );
@@ -486,5 +486,5 @@
 			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
 		}
-		else if( *cmd[1] == '#' )
+		else if( *cmd[1] == '#' || *cmd[1] == '&' )
 		{
 			if( cmd[2] )
@@ -557,5 +557,5 @@
 		else if( cmd[1] )
 		{
-			if( cmd[1][0] == '#' && cmd[1][1] )
+			if( ( cmd[1][0] == '#' || cmd[1][0] == '&' ) && cmd[1][1] )
 			{
 				user_t *u = user_find( irc, cmd[1] + 1 );
@@ -931,17 +931,29 @@
 }
 
-void irc_write_all( char *format, ... )
+void irc_write_all( int now, char *format, ... )
 {
 	va_list params;
 	GSList *temp;	
-
+	
 	va_start( params, format );
-
+	
 	temp = irc_connection_list;
-	while( temp!=NULL ) {
+	while( temp != NULL )
+	{
+		irc_t *irc = temp->data;
+		
+		if( now )
+		{
+			g_free( irc->sendbuffer );
+			irc->sendbuffer = g_strdup( "\r\n" );
+		}
 		irc_vawrite( temp->data, format, params );
+		if( now )
+		{
+			bitlbee_io_current_client_write( irc->io_channel, G_IO_OUT, irc );
+		}
 		temp = temp->next;
 	}
-
+	
 	va_end( params );
 	return;
@@ -1069,5 +1081,5 @@
 	irc_spawn( irc, u );
 	
-	irc_usermsg( irc, "Welcome to the BitlBee gateway!\n\nIf you've never used BitlBee before, please do read the help information using the help command. Lots of FAQ's are answered there." );
+	irc_usermsg( irc, "Welcome to the BitlBee gateway!\n\nIf you've never used BitlBee before, please do read the help information using the \x02help\x02 command. Lots of FAQ's are answered there." );
 	
 	irc->status = USTATUS_LOGGED_IN;
@@ -1313,5 +1325,5 @@
 	user_t *u = NULL;
 	
-	if( *nick == '#' )
+	if( *nick == '#' || *nick == '&' )
 	{
 		if( !( c = conv_findchannel( nick ) ) )
@@ -1428,4 +1440,6 @@
 	if( set_getint( irc, "buddy_sendbuffer" ) && set_getint( irc, "buddy_sendbuffer_delay" ) > 0 )
 	{
+		int delay;
+		
 		if( u->sendbuf_len > 0 && u->sendbuf_flags != flags)
 		{
@@ -1451,8 +1465,11 @@
 		strcat( u->sendbuf, "\n" );
 		
+		delay = set_getint( irc, "buddy_sendbuffer_delay" );
+		if( delay <= 5 )
+			delay *= 1000;
+		
 		if( u->sendbuf_timer > 0 )
 			g_source_remove( u->sendbuf_timer );
-		u->sendbuf_timer = g_timeout_add( set_getint( irc, "buddy_sendbuffer_delay" ) * 1000,
-		                                  buddy_send_handler_delayed, u );
+		u->sendbuf_timer = g_timeout_add( delay, buddy_send_handler_delayed, u );
 		
 		return( 1 );
Index: irc.h
===================================================================
--- irc.h	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ irc.h	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -118,5 +118,5 @@
 void irc_vawrite( irc_t *irc, char *format, va_list params );
 void irc_write( irc_t *irc, char *format, ... );
-void irc_write_all( char *format, ... );
+void irc_write_all( int now, char *format, ... );
 void irc_reply( irc_t *irc, int code, char *format, ... );
 G_MODULE_EXPORT int irc_usermsg( irc_t *irc, char *format, ... );
Index: log.c
===================================================================
--- log.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ log.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -134,12 +134,12 @@
 static void log_irc(int level, char *message) {
 	if(level==LOGLVL_ERROR)
-		irc_write_all("ERROR :Error: %s", message);
+		irc_write_all(1, "ERROR :Error: %s", message);
 	if(level==LOGLVL_WARNING)
-		irc_write_all("ERROR :Warning: %s", message);
+		irc_write_all(0, "ERROR :Warning: %s", message);
 	if(level==LOGLVL_INFO)
-		irc_write_all("ERROR :Informational: %s", message);	
+		irc_write_all(0, "ERROR :Informational: %s", message);	
 #ifdef DEBUG
 	if(level==LOGLVL_DEBUG)
-		irc_write_all("ERROR :Debug: %s", message);	
+		irc_write_all(0, "ERROR :Debug: %s", message);	
 #endif	
 
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/jabber/jabber.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -1123,5 +1123,5 @@
 		 */
 		struct jabber_add_permit *jap = g_new0(struct jabber_add_permit, 1);
-		gchar *msg = g_strdup_printf(_("The user %s wants to add you to their buddy list."),
+		gchar *msg = g_strdup_printf(_("The user %s wants to add you to his/her buddy list."),
 				Jid);
 
Index: protocols/msn/msn_util.c
===================================================================
--- protocols/msn/msn_util.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/msn/msn_util.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -166,5 +166,5 @@
 	
 	g_snprintf( buf, sizeof( buf ),
-	            "The user %s (%s) wants to add you to his/her buddy list. Do you want to allow this?",
+	            "The user %s (%s) wants to add you to his/her buddy list.",
 	            handle, realname );
 	do_ask_dialog( gc, buf, bla, msn_buddy_ask_yes, msn_buddy_ask_no );
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/nogaim.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -184,5 +184,5 @@
 			gc->prpl->set_away( gc, s, away );
 			if( set_getint( gc->irc, "debug" ) )
-				irc_usermsg( gc->irc, "Setting away state for %s to %s", gc->prpl->name, s );
+				serv_got_crap( gc, "Setting away state to %s", s );
 		}
 		else
@@ -277,5 +277,5 @@
 void set_login_progress( struct gaim_connection *gc, int step, char *msg )
 {
-	irc_usermsg( gc->irc, "%s(%s) - Logging in: %s", gc->prpl->name, gc->username, msg );
+	serv_got_crap( gc, "Logging in: %s", msg );
 }
 
@@ -283,5 +283,5 @@
 void hide_login_progress( struct gaim_connection *gc, char *msg )
 {
-	irc_usermsg( gc->irc, "%s(%s) - Login error: %s", gc->prpl->name, gc->username, msg );
+	serv_got_crap( gc, "Login error: %s", msg );
 }
 
@@ -289,5 +289,5 @@
 void hide_login_progress_error( struct gaim_connection *gc, char *msg )
 {
-	irc_usermsg( gc->irc, "%s(%s) - Logged out: %s", gc->prpl->name, gc->username, msg );
+	serv_got_crap( gc, "Logged out: %s", msg );
 }
 
@@ -308,6 +308,6 @@
 		msg = text;
 	
-	/* if( g_strcasecmp( set_getstr(gc->irc, "html" ), "strip" ) == 0 ) */
-	if( gc->flags & OPT_CONN_HTML )
+	if( ( g_strcasecmp( set_getstr( gc->irc, "strip_html" ), "always" ) == 0 ) ||
+	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( gc->irc, "strip_html" ) ) )
 		strip_html( msg );
 	
@@ -337,5 +337,5 @@
 	u = user_find( gc->irc, gc->irc->nick );
 	
-	irc_usermsg( gc->irc, "%s(%s) - Logged in", gc->prpl->name, gc->username );
+	serv_got_crap( gc, "Logged in" );
 	
 	gc->keepalive = g_timeout_add( 60000, send_keepalive, gc );
@@ -351,5 +351,5 @@
 		
 		if( u == NULL )
-			irc_usermsg( gc->irc, "\x02""***\x02"" BitlBee now supports ICQ server-side contact lists. "
+			serv_got_crap( gc, "\x02""***\x02"" BitlBee now supports ICQ server-side contact lists. "
 			                      "See \x02""help import_buddies\x02"" for more information." );
 	}
@@ -384,5 +384,5 @@
 	account_t *a;
 	
-	irc_usermsg( gc->irc, "%s(%s) - Signing off..", gc->prpl->name, gc->username );
+	serv_got_crap( gc, "Signing off.." );
 
 	gaim_input_remove( gc->keepalive );
@@ -416,5 +416,5 @@
 	{
 		int delay = set_getint( irc, "auto_reconnect_delay" );
-		irc_usermsg( gc->irc, "%s(%s) - Reconnecting in %d seconds..", gc->prpl->name, gc->username, delay);
+		serv_got_crap( gc, "Reconnecting in %d seconds..", delay );
 		
 		a->reconnect = 1;
@@ -430,5 +430,5 @@
 void do_error_dialog( struct gaim_connection *gc, char *msg, char *title )
 {
-	irc_usermsg( gc->irc, "%s(%s) - Error: %s", gc->prpl->name, gc->username, msg );
+	serv_got_crap( gc, "Error: %s", msg );
 }
 
@@ -459,10 +459,10 @@
 	
 	if( set_getint( irc, "debug" ) && 0 ) /* This message is too useless */
-		irc_usermsg( irc, "Receiving user add from protocol: %s", handle );
+		serv_got_crap( gc, "Receiving user add from handle: %s", handle );
 	
 	if( user_findhandle( gc, handle ) )
 	{
 		if( set_getint( irc, "debug" ) )
-			irc_usermsg( irc, "User already exists, ignoring add request: %s", handle );
+			serv_got_crap( gc, "User already exists, ignoring add request: %s", handle );
 		
 		return;
@@ -557,5 +557,5 @@
 		
 		if( ( gc->flags & OPT_LOGGED_IN ) && set_getint( gc->irc, "display_namechanges" ) )
-			irc_usermsg( gc->irc, "User `%s' changed name to `%s'", u->nick, u->realname );
+			serv_got_crap( gc, "User `%s' changed name to `%s'", u->nick, u->realname );
 	}
 }
@@ -590,6 +590,6 @@
 			if( set_getint( gc->irc, "debug" ) || g_strcasecmp( set_getstr( gc->irc, "handle_unknown" ), "ignore" ) != 0 )
 			{
-				irc_usermsg( gc->irc, "serv_got_update() for handle %s on connection %s(%s):", handle, gc->prpl->name, gc->username );
-				irc_usermsg( gc->irc, "loggedin = %d, type = %d", loggedin, type );
+				serv_got_crap( gc, "serv_got_update() for handle %s:", handle );
+				serv_got_crap( gc, "loggedin = %d, type = %d", loggedin, type );
 			}
 			
@@ -671,5 +671,5 @@
 		{
 			if( set_getint( irc, "debug" ) )
-				irc_usermsg( irc, "Ignoring message from unknown handle %s on connection %s(%s)", handle, gc->prpl->name, gc->username );
+				serv_got_crap( gc, "Ignoring message from unknown handle %s", handle );
 			
 			return;
@@ -693,11 +693,11 @@
 		else
 		{
-			irc_usermsg( irc, "Message from unknown handle %s on connection %s(%s):", handle, gc->prpl->name, gc->username );
+			serv_got_crap( gc, "Message from unknown handle %s:", handle );
 			u = user_find( irc, irc->mynick );
 		}
 	}
 	
-	/* if( g_strcasecmp( set_getstr( irc, "html" ), "strip" ) == 0 ) */
-	if( gc->flags & OPT_CONN_HTML )
+	if( ( g_strcasecmp( set_getstr( gc->irc, "strip_html" ), "always" ) == 0 ) ||
+	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( gc->irc, "strip_html" ) ) )
 		strip_html( msg );
 
@@ -753,5 +753,5 @@
 	
 	if( set_getint( gc->irc, "debug" ) )
-		irc_usermsg( gc->irc, "You were removed from conversation %d", (int) id );
+		serv_got_crap( gc, "You were removed from conversation %d", (int) id );
 	
 	for( c = gc->conversations; c && c->id != id; c = (l=c)->next );
@@ -798,6 +798,6 @@
 	for( c = gc->conversations; c && c->id != id; c = c->next );
 	
-	/* if( g_strcasecmp( set_getstr( gc->irc, "html" ), "strip" ) == 0 ) */
-	if( gc->flags & OPT_CONN_HTML )
+	if( ( g_strcasecmp( set_getstr( gc->irc, "strip_html" ), "always" ) == 0 ) ||
+	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( gc->irc, "strip_html" ) ) )
 		strip_html( msg );
 	
@@ -809,5 +809,5 @@
 		irc_privmsg( gc->irc, u, "PRIVMSG", c->channel, "", msg );
 	else
-		irc_usermsg( gc->irc, "Message from/to conversation %s@%d (unknown conv/user): %s", who, id, msg );
+		serv_got_crap( gc, "Message from/to conversation %s@%d (unknown conv/user): %s", who, id, msg );
 }
 
@@ -832,10 +832,10 @@
 	
 	s = g_new( char, 16 );
-	sprintf( s, "#chat_%03d", gc->irc->c_id++ );
+	sprintf( s, "&chat_%03d", gc->irc->c_id++ );
 	c->channel = g_strdup( s );
 	g_free( s );
 	
 	if( set_getint( gc->irc, "debug" ) )
-		irc_usermsg( gc->irc, "Creating new conversation: (id=%d,handle=%s)", id, handle );
+		serv_got_crap( gc, "Creating new conversation: (id=%d,handle=%s)", id, handle );
 	
 	return( c );
@@ -856,5 +856,5 @@
 	
 	if( set_getint( b->gc->irc, "debug" ) )
-		irc_usermsg( b->gc->irc, "User %s added to conversation %d", handle, b->id );
+		serv_got_crap( b->gc, "User %s added to conversation %d", handle, b->id );
 	
 	/* It might be yourself! */
@@ -890,5 +890,5 @@
 	
 	if( set_getint( b->gc->irc, "debug" ) )
-		irc_usermsg( b->gc->irc, "User %s removed from conversation %d (%s)", handle, b->id, reason ? reason : "" );
+		serv_got_crap( b->gc, "User %s removed from conversation %d (%s)", handle, b->id, reason ? reason : "" );
 	
 	/* It might be yourself! */
@@ -1031,8 +1031,13 @@
 		msg = buf;
 
-	if( u->gc->flags & OPT_CONN_HTML) {
-		char * html = escape_html(msg);
-		strncpy(buf, html, 8192);
-		g_free(html);
+	if( ( u->gc->flags & OPT_CONN_HTML ) && ( g_strncasecmp( msg, "<html>", 6 ) != 0 ) )
+	{
+		char *html;
+		
+		html = escape_html( msg );
+		strncpy( buf, html, 8192 );
+		g_free( html );
+		
+		msg = buf;
 	}
 	
Index: protocols/oscar/im.c
===================================================================
--- protocols/oscar/im.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/oscar/im.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -1996,4 +1996,88 @@
 }
 
+/*
+ * Subtype 0x0014 - Send a mini typing notification (mtn) packet.
+ *
+ * This is supported by winaim5 and newer, MacAIM bleh and newer, iChat bleh and newer, 
+ * and Gaim 0.60 and newer.
+ *
+ */
+int aim_im_sendmtn(aim_session_t *sess, guint16 type1, const char *sn, guint16 type2)
+{
+	aim_conn_t *conn;
+	aim_frame_t *fr;
+	aim_snacid_t snacid;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, 0x0002)))
+		return -EINVAL;
+
+	if (!sn)
+		return -EINVAL;
+
+	if (!(fr = aim_tx_new(sess, conn, AIM_FRAMETYPE_FLAP, 0x02, 10+11+strlen(sn)+2)))
+		return -ENOMEM;
+
+	snacid = aim_cachesnac(sess, 0x0004, 0x0014, 0x0000, NULL, 0);
+	aim_putsnac(&fr->data, 0x0004, 0x0014, 0x0000, snacid);
+
+	/*
+	 * 8 days of light
+	 * Er, that is to say, 8 bytes of 0's
+	 */
+	aimbs_put16(&fr->data, 0x0000);
+	aimbs_put16(&fr->data, 0x0000);
+	aimbs_put16(&fr->data, 0x0000);
+	aimbs_put16(&fr->data, 0x0000);
+
+	/*
+	 * Type 1 (should be 0x0001 for mtn)
+	 */
+	aimbs_put16(&fr->data, type1);
+
+	/*
+	 * Dest sn
+	 */
+	aimbs_put8(&fr->data, strlen(sn));
+	aimbs_putraw(&fr->data, sn, strlen(sn));
+
+	/*
+	 * Type 2 (should be 0x0000, 0x0001, or 0x0002 for mtn)
+	 */
+	aimbs_put16(&fr->data, type2);
+
+	aim_tx_enqueue(sess, fr);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x0014 - Receive a mini typing notification (mtn) packet.
+ *
+ * This is supported by winaim5 and newer, MacAIM bleh and newer, iChat bleh and newer, 
+ * and Gaim 0.60 and newer.
+ *
+ */
+static int mtn_receive(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	char *sn;
+	guint8 snlen;
+	guint16 type1, type2;
+
+	aim_bstream_advance(bs, 8); /* Unknown - All 0's */
+	type1 = aimbs_get16(bs);
+	snlen = aimbs_get8(bs);
+	sn = aimbs_getstr(bs, snlen);
+	type2 = aimbs_get16(bs);
+
+	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+		ret = userfunc(sess, rx, type1, sn, type2);
+
+	g_free(sn);
+
+	return ret;
+}
+
 static int snachandler(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
 {
@@ -2011,4 +2095,6 @@
 	else if (snac->subtype == 0x000c)
 		return msgack(sess, mod, rx, snac, bs);
+	else if (snac->subtype == 0x0014)
+		return mtn_receive(sess, mod, rx, snac, bs);
 
 	return 0;
Index: protocols/oscar/im.h
===================================================================
--- protocols/oscar/im.h	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/oscar/im.h	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -14,4 +14,5 @@
 #define AIM_CB_MSG_CLIENTAUTORESP 0x000b
 #define AIM_CB_MSG_ACK 0x000c
+#define AIM_CB_MSG_MTN 0x0014
 #define AIM_CB_MSG_DEFAULT 0xffff
 
@@ -194,4 +195,5 @@
 
 int aim_send_im_ch2_geticqmessage(aim_session_t *sess, const char *sn, int type);
+int aim_im_sendmtn(aim_session_t *sess, guint16 type1, const char *sn, guint16 type2);
 int aim_send_im_ch2_statusmessage(aim_session_t *sess, const char *sender, const guint8 *cookie, const char *message, const guint8 state, const guint16 dc);
 
Index: protocols/oscar/oscar.c
===================================================================
--- protocols/oscar/oscar.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/oscar/oscar.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -221,5 +221,5 @@
 static int gaim_ssi_parselist    (aim_session_t *, aim_frame_t *, ...);
 static int gaim_ssi_parseack     (aim_session_t *, aim_frame_t *, ...);
-
+static int gaim_parsemtn         (aim_session_t *, aim_frame_t *, ...);
 static int gaim_icqinfo          (aim_session_t *, aim_frame_t *, ...);
 static int gaim_parseaiminfo     (aim_session_t *, aim_frame_t *, ...);
@@ -556,4 +556,5 @@
 	aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_SSI, AIM_CB_SSI_SRVACK, gaim_ssi_parseack, 0);
 	aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_LOC, AIM_CB_LOC_USERINFO, gaim_parseaiminfo, 0);
+	aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_MSG, AIM_CB_MSG_MTN, gaim_parsemtn, 0);
 
 	((struct oscar_data *)gc->proto_data)->conn = bosconn;
@@ -1676,4 +1677,5 @@
 
 	/* Maybe senderwarn and recverwarn should be user preferences... */
+	params->flags = 0x0000000b;
 	params->maxmsglen = 8000;
 	params->minmsginterval = 0;
@@ -2433,4 +2435,23 @@
 }
 
+int gaim_parsemtn(aim_session_t *sess, aim_frame_t *fr, ...)
+{
+	struct gaim_connection * gc = sess->aux_data;
+	va_list ap;
+	guint16 type1, type2;
+	char * sn;
+
+	va_start(ap, fr);
+	type1 = va_arg(ap, int);
+	sn = va_arg(ap, char*);
+	type2 = va_arg(ap, int);
+	va_end(ap);
+
+	if(type2 == 0x0001 || type2 == 0x0002)
+		serv_got_typing(gc, sn, 0);
+
+	return 1;
+}
+
 static char *oscar_get_status_string( struct gaim_connection *gc, int number )
 {
@@ -2459,4 +2480,10 @@
 		return( "Away" );
 	}
+}
+
+int oscar_send_typing(struct gaim_connection *gc, char * who, int typing)
+{
+	struct oscar_data *od = gc->proto_data;
+	return( aim_im_sendmtn(od->sess, 1, who, typing ? 0x0002 : 0x0000) );
 }
 
@@ -2482,4 +2509,5 @@
 	ret->cmp_buddynames = aim_sncmp;
 	ret->get_status_string = oscar_get_status_string;
+	ret->send_typing = oscar_send_typing;
 
 	register_protocol(ret);
Index: protocols/util.c
===================================================================
--- protocols/util.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/util.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -377,6 +377,4 @@
 	if( html == NULL )
 		return( NULL );
-	if( g_strncasecmp( html, "<html>", 6 ) == 0 )
-		return( g_strdup( html ) );
 	
 	ret = g_string_new( "" );
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ protocols/yahoo/yahoo.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -845,6 +845,4 @@
 	if( c )
 		add_chat_buddy( c, who );
-	else if( set_getint( gc->irc, "debug" ) )
-		serv_got_crap( gc, "Got ext_yahoo_conf_userjoin() from %s for unknown conference %s", who, room );
 }
 
@@ -858,6 +856,4 @@
 	if( c )
 		remove_chat_buddy( c, who, "" );
-	else if( set_getint( gc->irc, "debug" ) )
-		serv_got_crap( gc, "Got ext_yahoo_conf_userleave() from %s for unknown conference %s", who, room );
 }
 
Index: query.c
===================================================================
--- query.c	(revision cc9079ee091707aba3d5b0580a6191eb4541cbec)
+++ query.c	(revision 9c8ae507985a29b41a22cf30b803141e9ba82a9b)
@@ -127,14 +127,14 @@
 		disp = 1;
 	}
-	
+	//Using irc_usermsg instead of serv_got_crap because \x02A is a char too, so a SPACE is needed.	
 	if( ans )
 	{
 		q->yes( NULL, q->data );
-		irc_usermsg( irc, "Accepted: %s", q->question );
+		serv_got_crap( q->gc, "Accepted: %s", q->question );
 	}
 	else
 	{
 		q->no( NULL, q->data );
-		irc_usermsg( irc, "Rejected: %s", q->question );
+		serv_got_crap( q->gc, "Rejected: %s", q->question );
 	}
 	q->data = NULL;
@@ -149,9 +149,11 @@
 {
 	if( q->gc )
-		irc_usermsg( irc, "Question on %s connection (handle %s):", q->gc->prpl->name, q->gc->username );
+	{
+		serv_got_crap( q->gc, "New request: %s\nYou can use the \2yes\2/\2no\2 commands to accept/reject this request.", q->question );
+	}
 	else
-		irc_usermsg( irc, "Question:" );
-	
-	irc_usermsg( irc, "%s\nYou can use the yes/no commands to answer this question.", q->question );
+	{
+		irc_usermsg( irc, "New request: %s\nYou can use the \2yes\2/\2no\2 commands to accept/reject this request.", q->question );
+	}
 }
 
